<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrg as OrganizationProductEntity;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrgColetor as EntidadeOmProdutoOrgColetor;
use Teknisa\Model\Util\NovoCodigo;

class ProdutoOrg {
    
    public function save(OrganizationProductEntity $organizationProduct = null, $nrOrgId, $nrProdutoId, $currentUserId, $currentOrganizationId, $dateNow, $idAtivo = 'S', $idProdutoSaas = 'S'){
        if(!$organizationProduct) {
            $organizationProduct = new OrganizationProductEntity();
            $novoCodigo = NovoCodigo::geraCodigo($currentOrganizationId, 'OM_PRODUTO_ORG', 1, 10, true, false);
            $organizationProduct->setId($novoCodigo);
            $organizationProduct->setNrorgId($nrOrgId);
            $organizationProduct->setDtinclusao($dateNow);
            $organizationProduct->setNrprodutoId($nrProdutoId);
            $organizationProduct->setNrorg($currentOrganizationId);
            $organizationProduct->setCdoperinclusao($currentUserId);
            $organizationProduct->setNrorginclusao($currentOrganizationId);
        }
        $organizationProduct->setIdprodutosaas($idProdutoSaas);
        $organizationProduct->setIdativo($idAtivo);
        $organizationProduct->setDtultatu($dateNow);
        $organizationProduct->setCdoperultatu($currentUserId);
        $organizationProduct->setNrorgultatu($currentOrganizationId);

        return $organizationProduct;
    }

    public function saveProductOrgCollector(EntidadeOmProdutoOrgColetor $collector = null, $currentOrgId, $codOperador, $dateNow,
                         $idColetor, $dsStringConexao, $idUtWallet, $dsUsuarioBanco, $dsSenhaBanco, $idativo, $nrProdutoOrgId, $idTpBanco)
    {
        if ($collector === null) {
            $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PRODUTO_ORG_COLETOR", 1, 10, false, false);
            $collector = new EntidadeOmProdutoOrgColetor();
            $collector->setId($novoCodigo);
            $collector->setCdoperinclusao($codOperador);
            $collector->setNrorginclusao($currentOrgId);
            $collector->setDtinclusao($dateNow);
            $collector->setNrorg($currentOrgId);
        }
        
        $collector->setCdoperultatu($codOperador);
        $collector->setNrorgultatu($currentOrgId);
        $collector->setDtultatu($dateNow);
        
        $collector->setIdativo($idativo);
        $collector->setNrprodutoOrgId($nrProdutoOrgId);
        $collector->setIdcoletor($idColetor);
        $collector->setDsstringconexao($dsStringConexao);
        $collector->setIdutwallet($idUtWallet);
        $collector->setDsusuariobanco($dsUsuarioBanco);
        $collector->setDssenhabanco($dsSenhaBanco);
        $collector->setIdtpbanco($idTpBanco);
        
        return $collector;
    }
}