/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: INSERE_FORMULARIONF

DESCRIO:
   PROCEDIMENTO PARA INSERIR OS FORMULARIOS PENDENTES NA TABELA FORMULARIONF.

@C:\WEB_407\SQL\End_Conv\SQLSERVER\5053_DFSSTPS.SQL
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'INSERE_FORMULARIONF' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE INSERE_FORMULARIONF
GO

CREATE PROCEDURE INSERE_FORMULARIONF (
      @P_CDCTRLNUMENF  VARCHAR(10),
      @P_NRCTRLFORMNF  VARCHAR(10),
      @P_NRNUMEINI     VARCHAR(20),
      @P_NRNUMEFIN     VARCHAR(20),
      @P_CDFILIAL      VARCHAR(04))
AS

   DECLARE @V_CDCTRLNUMENF VARCHAR(10);
   DECLARE @V_NRCTRLFORMNF VARCHAR(10);
   DECLARE @V_NRFORMULARNF VARCHAR(20);
   DECLARE @V_IDSTATUSFORM VARCHAR(01);
   DECLARE @V_NRNUMEINIFRM DOUBLE PRECISION;
   DECLARE @V_NRNUMEFINFRM DOUBLE PRECISION;
   DECLARE @V_NRTAMNUMNFUT VARCHAR(04);

BEGIN

   SELECT @V_CDCTRLNUMENF = MAX(CDCTRLNUMENF), @V_NRCTRLFORMNF = MAX(NRCTRLFORMNF),
          @V_NRFORMULARNF = MAX(NRFORMULARNF), @V_IDSTATUSFORM = MAX(IDSTATUSFORM)
   FROM FORMULARIONF
   WHERE (CDCTRLNUMENF = @P_CDCTRLNUMENF) AND
         (NRCTRLFORMNF = @P_NRCTRLFORMNF);

   IF NOT(@V_CDCTRLNUMENF IS NULL) BEGIN
      DELETE FROM FORMULARIONF
      WHERE (CDCTRLNUMENF = @P_CDCTRLNUMENF) AND
            (NRCTRLFORMNF = @P_NRCTRLFORMNF);
   END;

   SET @V_NRNUMEINIFRM = CONVERT(INT, @P_NRNUMEINI);
   SET @V_NRNUMEFINFRM = CONVERT(INT, @P_NRNUMEFIN);

   SELECT @V_NRTAMNUMNFUT = ISNULL(MAX(NRTAMNUMNFUT), 7)
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   WHILE (@V_NRNUMEINIFRM <= @V_NRNUMEFINFRM) BEGIN
      INSERT INTO FORMULARIONF
         (CDCTRLNUMENF, NRCTRLFORMNF, NRFORMULARNF, IDSTATUSFORM)
      VALUES
         (@P_CDCTRLNUMENF, @P_NRCTRLFORMNF, RIGHT(REPLICATE('0', @V_NRTAMNUMNFUT) + CONVERT(VARCHAR,@V_NRNUMEINIFRM), @V_NRTAMNUMNFUT), 'P');

      SET @V_NRNUMEINIFRM = @V_NRNUMEINIFRM + 1;
   END;

END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'INSERE_FORMULARIONF','5.07.011';
GO

